from byu_pytest_utils import max_score, run_python, this_folder, test_files


@max_score(10)
def test_anagrams_dog():
    captured = run_python(
        this_folder / "anagrams.py",
        test_files / "dog.txt",
        stdin='dgo\ngod\ndog'
    )
    lines = captured.splitlines()
    # First line should be scattered version of the word with n - 1 spaces.
    expected = [" ", " ", "d", "g", "o"]
    observed = sorted(lines[0])
    assert observed == expected
    # First two guesses are incorrect
    # Prompt should be spelled "Guess: "
    assert lines[1] == "Guess: Incorrect"
    assert lines[2] == "Guess: Incorrect"
    # Last guess is correct
    assert lines[3] == "Guess: Correct!"
    # Three guesses total
    assert lines[4] == "Total Guesses: 3"
