from byu_pytest_utils import max_score, run_python, this_folder


@max_score(2)
def test_math_practice_one_problem_incorrect():
    captured = run_python(this_folder / "math_practice.py", 1, 1, 1, stdin="1")

    lines = captured.splitlines()
    # First Line should say "Questions 1: "
    assert lines[0] == "Question 1: "
    assert lines[1] == "1 + 1"
    assert lines[2] == "Answer: You Scored 0 Points!"
    assert lines[3] == "Correct Answers: "
    assert lines[4] == "Incorrect Answers: 1 + 1"


@max_score(2)
def test_math_practice_one_problem_correct():
    captured = run_python(this_folder / "math_practice.py", 1, 2, 2, stdin="4")
    lines = captured.splitlines()
    # First Line should say "Questions 1: "
    assert lines[0] == "Question 1: "
    assert lines[1] == "2 + 2"
    assert lines[2] == "Answer: You Scored 1 Points!"
    assert lines[3] == "Correct Answers: 2 + 2"
    assert lines[4] == "Incorrect Answers: "


@max_score(2)
def test_math_practice_three_problems():
    captured = run_python(this_folder / "math_practice.py", 3, 2, 2, stdin="4\n4\n1")
    lines = captured.splitlines()
    assert lines[0] == "Question 1: "
    assert lines[2] == "Answer: Question 2: "
    assert lines[4] == "Answer: Question 3: "
    assert lines[6] == "Answer: You Scored 2 Points!"


def check_for_plus(lines):
    for line in lines:
        if "+" in line:
            return True
    return False


@max_score(2)
def test_math_practice_small_bounds():
    captured = run_python(this_folder / "math_practice.py", 3, 1, 5, stdin="5\n1\n5")
    lines = captured.splitlines()
    assert check_for_plus(lines)
    for line in lines:
        if "+" in line and "orrect" not in line:
            numbers = line.split("+")
            number1 = int(numbers[0].strip())
            number2 = int(numbers[1].strip())
            assert 1 <= number1 <= 5
            assert 1 <= number2 <= 5


@max_score(2)
def test_math_practice_large_bounds():
    captured = run_python(this_folder / "math_practice.py", 3, 1, 1000000000, stdin="5\n1\n5")
    lines = captured.splitlines()
    assert check_for_plus(lines)
    for line in lines:
        if "+" in line and "orrect" not in line:
            numbers = line.split("+")
            number1 = int(numbers[0].strip())
            number2 = int(numbers[1].strip())
            assert 1 <= number1 <= 1000000000
            assert 1 <= number2 <= 1000000000
